const execSync = require('child_process').execSync;
const dns = require('dns');
const chalk = require('chalk');
const spawn = require('react-dev-utils/crossSpawn');

async function yarn(args, root){
    let command;
    let isOnline = await checkIfOnline()

    command = 'yarnpkg';
    if (!isOnline) {
        args.push('--offline');
    }
    args.push('--cwd');
    args.push(root);

    if (!isOnline) {
        console.log(chalk.yellow('请联网.'));
        console.log();
    }
    spawn.sync(command, args, { stdio: 'inherit' });
}

function getProxy() {
    if (process.env.https_proxy) {
        return process.env.https_proxy;
    } else {
        try {
            let httpsProxy = execSync('npm config get https-proxy')
                .toString()
                .trim();
            return httpsProxy !== 'null' ? httpsProxy : undefined;
        } catch (e) {
            return;
        }
    }
}

function checkIfOnline(useYarn) {
    return new Promise(resolve => {
        dns.lookup('registry.yarnpkg.com', err => {
            let proxy;
            if (err != null && (proxy = getProxy())) {
                dns.lookup(url.parse(proxy).hostname, proxyErr => {
                    resolve(proxyErr == null);
                });
            } else {
                resolve(err == null);
            }
        });
    });
}

module.exports = {
    yarn : yarn
}

